--[[
    Author: PeterAH (Modding-Welt)
    Mod name: Adjust Working Speed
    Version: 1.0.0.0
    Date: October 2020
    Contact: https://www.modding-welt.com
    Discord: [MW] PeterAH#5807
]]

farmIdSelect = {}

local _modDirectory = g_currentModDirectory

function farmIdSelect.prerequisitesPresent(specializations)
    return true
end

function farmIdSelect.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onLoad", farmIdSelect)
end


function farmIdSelect:onLoad(savegame)
	local spec = self.spec_farmIdSelect

	spec.farmId = self:getOwnerFarmId
	spec.isMultiplayer = g_currentMission.missionDynamicInfo.isMultiplayer

	if savegame ~= nil then
		local xmlFile = savegame.xmlFile
		local farmId = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#farmId"))

		
		local i = 0
            while true do
                local key = string.format("%s.Farm(%d)", savegame.key, i)
                if not hasXMLProperty(xmlFile, key) then
                    break
                end
                i = i + 1
            end
		if spec.isMultiplayer then		
			spec.farmId = Utils.getNoNil(getXMLInt(xmlFile, farmId), self:getOwnerFarmId())
		else
			spec.farmId = FarmManager.SINGLEPLAYER_FARM_ID
		end
		farmIdSelect:updateFarmID(self, spec.farmId, true)
	end
end

function farmIdSelect:saveToXMLFile(xmlFile, key)
	if self.spec_vehicle ~= nil then
		setXMLInt(xmlFile, key .. "#farmId", self:getOwnerFarmId())
	end
end

function farmIdSelect:action_baleId_Change(actionName, keyStatus, arg3, arg4, arg5)
	local spec = self.vehicle	
	spec.FarmIDs ={}
	if spec.isMultiplayer then
		for i=1,14,1 do
			if g_currentMission.accessHandler:canFarmAccessOtherId(self:getActiveFarm(),i) then
				table.insert(spec.FarmIDs,i)
			end
		end
	else
		table.insert(spec.FarmIDs,1)
	end
end